package com.kingdee.eas.custom.handover.app;

import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.custom.handover.*;
import com.kingdee.eas.custom.handover.utils.WorkHandoverUtil;
import com.kingdee.eas.hr.affair.AffairBizException;
import com.kingdee.eas.hr.affair.IResignBizBill;
import com.kingdee.eas.hr.affair.ResignBizBillFactory;
import com.kingdee.eas.hr.affair.ResignBizBillInfo;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.eas.common.EASBizException;

import java.lang.String;
import java.sql.Date;
import java.util.HashSet;
import java.util.Set;

public class WorkHandoverControllerBean extends AbstractWorkHandoverControllerBean {
    private static Logger logger = Logger.getLogger(WorkHandoverControllerBean.class);

    @Override
    protected IObjectPK _submit(Context ctx, IObjectValue model) throws BOSException, EASBizException {
        return super._submit(ctx, model);
    }

    /**
     * ɾ
     *
     * @param ctx
     * @param pk
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _delete(Context ctx, IObjectPK pk) throws BOSException, EASBizException {
        HRBillBaseInfo info = (HRBillBaseInfo) this._getValue(ctx, pk);
        HRBillStateEnum billState = info.getBillState();
        boolean isRemovable = true;
        //ύСͨĵݲɾ
        if (HRBillStateEnum.SUBMITED.equals(billState)
                || HRBillStateEnum.AUDITING.equals(billState)
                || HRBillStateEnum.AUDITED.equals(billState)) {
            isRemovable = false;
        }
        if (!isRemovable) {
            throw new AffairBizException(AffairBizException.BILLCANTDELETE);
        }
        super._delete(ctx, pk);
    }

    /**
     * 
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _save(Context ctx, IObjectValue model) throws BOSException, EASBizException {
        WorkHandoverInfo info = (WorkHandoverInfo) model;
        WorkHandoverEntryCollection entrys = info.getEntrys();
        if (entrys.isEmpty()) {
            throw new BOSException("ӵ¼Ϊ!");
        }
        //洢з¼󶨵ְid
        Set<String> resignBizBillIds = new HashSet<String>();
        IWorkHandoverEntry iWorkHandoverEntry = WorkHandoverEntryFactory.getLocalInstance(ctx);
        IResignBizBill iResignBizBill = ResignBizBillFactory.getLocalInstance(ctx);
        for (int i = 0; i < entrys.size(); i++) {
            WorkHandoverEntryInfo workHandoverEntryInfo = entrys.get(i);
            ResignBizBillInfo resignBizBill = workHandoverEntryInfo.getResignBizBill();
            if (resignBizBill == null) {
                throw new BOSException("ְΪ!");
            }
            //ְ
            String resignBizBillNumber = resignBizBill.getNumber();
            //ְid
            String resignBizBillId = resignBizBill.getId().toString();
            //1.жϱݷ¼Ƿͬһְӵ
            if (resignBizBillIds.contains(resignBizBillId)) {
                throw new BOSException("¼Ѿͬһְ˽ӵ!");
            }
            //2.жϱݷ¼Ƿְظӵ
            FilterInfo filterInfo = new FilterInfo();
            FilterItemCollection filterItems = filterInfo.getFilterItems();
            filterItems.add(new FilterItemInfo("resignBizBill", resignBizBillId));
            if (info.getId() != null) {
                filterItems.add(new FilterItemInfo("parent.id", info.getId(), CompareType.NOTEQUALS));
            }
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("parent.number");
            EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
            WorkHandoverEntryCollection workHandoverEntryCol = iWorkHandoverEntry.getWorkHandoverEntryCollection(viewInfo);
            if (!workHandoverEntryCol.isEmpty()) {
                if (StringUtils.isEmpty(resignBizBillNumber)) {
                    ResignBizBillInfo resignBizBillInfo = iResignBizBill.getResignBizBillInfo(new ObjectUuidPK(resignBizBillId));
                    resignBizBillNumber = resignBizBillInfo.getNumber();
                }
                String number = workHandoverEntryCol.get(0).getParent().getNumber();
                throw new BOSException("ְ[" + resignBizBillNumber + "]Ѿӵ[" + number + "]ظ!");
            }
            resignBizBillIds.add(resignBizBillId);
            //3.ְ
            Date leftDate = workHandoverEntryInfo.getDate("leftDate");
            WorkHandoverUtil.setResignBizDate(ctx, leftDate, workHandoverEntryInfo);
        }
        return super._save(ctx, model);
    }
}