package com.kingdee.eas.custom.handover.task;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.data.SortType;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.function.WfEventListenerStateManager;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.handover.*;
import com.kingdee.eas.custom.handover.utils.WorkHandoverUtil;
import com.kingdee.eas.hr.affair.*;
import com.kingdee.eas.hr.ats.WorkCalendarItemCollection;
import com.kingdee.eas.hr.ats.WorkCalendarItemInfo;
import com.kingdee.util.DateTimeUtils;
import org.apache.log4j.Logger;

import java.util.Date;

public class WorkHandoverFacadeControllerBean extends AbstractWorkHandoverFacadeControllerBean {
    private static Logger logger = Logger.getLogger(WorkHandoverFacadeControllerBean.class);

    /**
     * ύӵ
     *
     * @param ctx
     * @param preDays ǰ
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _createAndSubmitHandover(
            Context ctx,
            int preDays
    ) throws BOSException, EASBizException {
        super._createAndSubmitHandover(ctx, preDays);
        //
        Date toDay = DateTimeUtils.truncateDate(new Date());
        boolean isWorkDay = WorkHandoverUtil.isWorkDay(ctx, toDay);
        if (!isWorkDay) {
            logger.error(DateTimeUtils.format(toDay) + "ǹգִдӵ");
            return;
        }
        if (preDays <= 0) {
            preDays = 1;
        }
        IResignBizBillEntry iResignBizBillEntry = ResignBizBillEntryFactory.getLocalInstance(ctx);
        IWorkHandover iWorkHandover = WorkHandoverFactory.getLocalInstance(ctx);
        IWorkHandoverEntry iWorkHandoverEntry = WorkHandoverEntryFactory.getLocalInstance(ctx);
        //1.ѯְͨҵǰڵְǰ
        WorkCalendarItemCollection workCalendarItemCollection =
                WorkHandoverUtil.getWorkCalendarItemCollection(ctx, SortType.ASCEND, toDay, 30);
        if (workCalendarItemCollection.size() < preDays) {
            throw new BOSException("_createAndSubmitHandover ûлȡָ");
        }
        WorkCalendarItemInfo workCalendarItemInfo = workCalendarItemCollection.get(preDays - 1);
        Date date = workCalendarItemInfo.getDate();
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //״̬Ϊͨ
        filterItems.add(new FilterItemInfo("bill.billState", "3"));
        //ְڴڵڽ
        filterItems.add(new FilterItemInfo("bizDate", toDay, CompareType.GREATER_EQUALS));
        //ְСڵںn
        filterItems.add(new FilterItemInfo("bizDate", date, CompareType.LESS_EQUALS));
        //
        filterItems.add(new FilterItemInfo("variationReason.number", "CTYY00302", CompareType.NOTEQUALS));
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("person.*");
        sic.add("bill.*");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        //ȡְ¼
        ResignBizBillEntryCollection resignBizBillEntryCol = iResignBizBillEntry.getResignBizBillEntryCollection(viewInfo);
        for (int i = 0; i < resignBizBillEntryCol.size(); i++) {
            ResignBizBillEntryInfo resignBizBillEntryInfo = resignBizBillEntryCol.get(i);
            ResignBizBillInfo resignBizBillInfo = resignBizBillEntryInfo.getBill();
            try {
                //ǷڸְӦĽӵ
                FilterInfo existsFilterInfo = new FilterInfo();
                existsFilterInfo.getFilterItems().add(new FilterItemInfo("resignBizBill", resignBizBillInfo.getId()));
                if (iWorkHandoverEntry.exists(existsFilterInfo)) {
                    //ڶͬһְĽӵ,
                    continue;
                }
                //2.ְӵ
                WorkHandoverInfo workHandoverInfo = WorkHandoverUtil.generateWorkHandoverInfo(ctx, resignBizBillEntryInfo);
                //3.ύ
                //ٴμ鹤ӵǷ
                if (!iWorkHandoverEntry.exists(existsFilterInfo)) {
                    //ύ
                    WfEventListenerStateManager listenerStateManager = WfEventListenerStateManager.getInstance();
                    boolean isOpen = listenerStateManager.isEnable();
                    //
                    if (!isOpen) {
                        listenerStateManager.enableEventListener();
                    }
                    iWorkHandover.submit(workHandoverInfo);
                    //״̬ǹصģص
                    if (!isOpen) {
                        listenerStateManager.disableEventListener();
                    }
                }
            } catch (Exception e) {
                logger.error("Զӵ񱨴: " + e.getMessage(), e);
                logger.error("Զӵ񱨴, resignBizBillInfoId : " + resignBizBillInfo.getId());
            }
        }
    }
}