package com.kingdee.eas.custom.handover.utils;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.data.SortType;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.org.PositionInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.handover.WorkHandoverEntryInfo;
import com.kingdee.eas.custom.handover.WorkHandoverInfo;
import com.kingdee.eas.hr.affair.ResignBizBillEntryInfo;
import com.kingdee.eas.hr.ats.IWorkCalendarItem;
import com.kingdee.eas.hr.ats.WorkCalendarItemCollection;
import com.kingdee.eas.hr.ats.WorkCalendarItemFactory;
import com.kingdee.eas.hr.ats.WorkCalendarItemInfo;
import com.kingdee.eas.hr.ats.util.AtsDateUtils;
import com.kingdee.eas.hr.base.EmpPosOrgRelationCollection;
import com.kingdee.eas.hr.base.EmpPosOrgRelationFactory;
import com.kingdee.eas.hr.base.EmpPosOrgRelationInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.util.DateTimeUtils;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.util.*;

/**
 * @Description ӵ
 * @Date 2025/5/30 14:28
 * @Created by Heyuan
 */
public class WorkHandoverUtil {
    private static Logger logger = Logger.getLogger(WorkHandoverUtil.class);
    //ӵ/ְ¼ӳֶ
    private static Map<String, String> propertyMap = new HashMap<String, String>();

    static {
        propertyMap.put("person", "person");//Ա
        propertyMap.put("adminOrg", "adminOrg");//֯
        propertyMap.put("resHrBizDefine", "hrBizDefine");//ְ䶯
        propertyMap.put("position", "position");//ְλ
        propertyMap.put("jobGrade", "jobGrade");//ְ
        propertyMap.put("oldEmpType", "oldEmpType");//ְǰùϵ״̬
        propertyMap.put("empType", "empType");//ְùϵ״̬
        propertyMap.put("resVariationReason", "variationReason");//ְԭ
        propertyMap.put("leftCompanyDate", "leftCompanyDate");//
        propertyMap.put("leftDate", "bizDate");//ְ
    }

    /**
     * ɹӵ
     *
     * @param resignBizBillEntryInfo
     * @return
     */
    public static WorkHandoverInfo generateWorkHandoverInfo(
            Context ctx,
            ResignBizBillEntryInfo resignBizBillEntryInfo
    ) throws BOSException {
        try {
            //Աid
            String personId = resignBizBillEntryInfo.getPerson().getId().toString();
            //ӵ
            WorkHandoverInfo workHandoverInfo = new WorkHandoverInfo();
            workHandoverInfo.setBillState(HRBillStateEnum.SUBMITED);
            HROrgUnitInfo hrOrgUnitInfo = new HROrgUnitInfo();
            hrOrgUnitInfo.setId(BOSUuid.read("00000000-0000-0000-0000-000000000000CCE7AED4"));
            workHandoverInfo.setHrOrgUnit(hrOrgUnitInfo);
            //ӵ¼
            WorkHandoverEntryInfo workHandoverEntryInfo = new WorkHandoverEntryInfo();
            workHandoverInfo.getEntrys().add(workHandoverEntryInfo);
            //ֵ
            for (String workHandoverAttrName : propertyMap.keySet()) {
                String resignBizBillEntryAttrName = propertyMap.get(workHandoverAttrName);
                workHandoverEntryInfo.put(workHandoverAttrName, resignBizBillEntryInfo.get(resignBizBillEntryAttrName));
            }
            //ְ¼id
            workHandoverEntryInfo.setResignBizBillEntryId(resignBizBillEntryInfo.getId().toString());
            //ְ
            workHandoverEntryInfo.setResignBizBill(resignBizBillEntryInfo.getBill());
            //Ƿ쵼
            workHandoverEntryInfo.setBoolean("isLeader", isLeader(ctx, personId));
            //ְ
            Date bizDate = resignBizBillEntryInfo.getBizDate();
            setResignBizDate(ctx, bizDate, workHandoverEntryInfo);
            return workHandoverInfo;
        } catch (BOSException e) {
            logger.error("generateWorkHandoverInfo error: " + e.getMessage(), e);
            throw new BOSException(e);
        }
    }

    /**
     * ȡָڵΧڵĹ
     *
     * @param ctx
     * @param bizDate  ָ
     * @param afterDay Ӻ
     * @return
     * @throws BOSException
     */
    public static WorkCalendarItemCollection getWorkCalendarItemCollection(
            Context ctx,
            SortType sortType,
            Date bizDate,
            int afterDay
    ) throws BOSException {
        if (bizDate == null) {
            throw new BOSException("getWorkCalendarItemCollection bizDate is null");
        }
        IWorkCalendarItem iWorkCalendarItem = WorkCalendarItemFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        Date afterDate = AtsDateUtils.getPreDay(bizDate, -afterDay);
        if (bizDate.before(afterDate)) {
            //ڴڵָ
            filterItems.add(new FilterItemInfo("date", bizDate, CompareType.GREATER_EQUALS));
            //Сڵְǰ
            filterItems.add(new FilterItemInfo("date", afterDate, CompareType.LESS_EQUALS));
        } else {
            filterItems.add(new FilterItemInfo("date", afterDate, CompareType.GREATER_EQUALS));
            filterItems.add(new FilterItemInfo("date", bizDate, CompareType.LESS_EQUALS));
        }
        //
        filterItems.add(new FilterItemInfo("dayType", "0"));
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("date");
        SorterItemCollection sorts = new SorterItemCollection();
        //
        SorterItemInfo sorterItemInfo = new SorterItemInfo("date");
        if (sortType != null) {
            sorterItemInfo.setSortType(sortType);
        }
        sorts.add(sorterItemInfo);
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, sorts);
        WorkCalendarItemCollection workCalendarItemCollection = iWorkCalendarItem.getWorkCalendarItemCollection(viewInfo);
        if (workCalendarItemCollection.isEmpty()) {
            //ûвѯ
            throw new BOSException("δѯ");
        }
        return workCalendarItemCollection;
    }


    /**
     * жָǷΪ
     *
     * @param ctx
     * @param bizDate ָ
     * @return
     * @throws BOSException
     */
    public static boolean isWorkDay(
            Context ctx,
            Date bizDate
    ) throws BOSException, EASBizException {
        if (bizDate == null) {
            throw new BOSException("isWorkDay bizDate is null");
        }
        IWorkCalendarItem iWorkCalendarItem = WorkCalendarItemFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //ڵָ
        filterItems.add(new FilterItemInfo("date", bizDate));
        //
        filterItems.add(new FilterItemInfo("dayType", "0"));
        return iWorkCalendarItem.exists(filterInfo);
    }

    /**
     * ȡԱǰְ
     *
     * @param ctx
     * @param personId Աid
     * @return
     * @throws BOSException
     */
    public static EmpPosOrgRelationCollection getCurrntEmpOrgRelation(
            Context ctx,
            String personId
    ) throws BOSException {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("position.*");
        sic.add("adminOrg.level");
        EntityViewInfo view = new EntityViewInfo();
        FilterInfo filter = new FilterInfo();
        filter.getFilterItems().add(new FilterItemInfo("person.id", personId));
        Date curDate = DateTimeUtils.truncateDate(new Date());
        filter.getFilterItems().add(new FilterItemInfo(HistoryConstant.EFFDT, curDate, CompareType.LESS_EQUALS));
        filter.getFilterItems().add(new FilterItemInfo(HistoryConstant.LEFFDT, curDate, CompareType.GREATER_EQUALS));
        view.setFilter(filter);
        view.setSelector(sic);
        EmpPosOrgRelationCollection collection = EmpPosOrgRelationFactory.getLocalInstance(ctx).getEmpPosOrgRelationCollection(view);
        return collection;
    }

    /**
     * ͨϼְλid,ȡ¼ְλְԱϢ
     *
     * @param ctx
     * @param positionId ϼְλid
     * @return
     * @throws BOSException
     */
    public static EmpPosOrgRelationCollection getCurrntEmpOrgRelationByParentPositionId(
            Context ctx,
            String positionId
    ) throws BOSException {
        EntityViewInfo view = new EntityViewInfo();
        FilterInfo filter = new FilterInfo();
        filter.getFilterItems().add(new FilterItemInfo("position.parent.id", positionId));
        Date curDate = DateTimeUtils.truncateDate(new Date());
        filter.getFilterItems().add(new FilterItemInfo(HistoryConstant.EFFDT, curDate, CompareType.LESS_EQUALS));
        filter.getFilterItems().add(new FilterItemInfo(HistoryConstant.LEFFDT, curDate, CompareType.GREATER_EQUALS));
        view.setFilter(filter);
        EmpPosOrgRelationCollection collection = EmpPosOrgRelationFactory.getLocalInstance(ctx).getEmpPosOrgRelationCollection(view);
        return collection;
    }

    /**
     * жָԱǷΪ쵼
     *
     * @param ctx
     * @param personId
     * @return
     * @throws BOSException
     */
    public static boolean isLeader(Context ctx, String personId) throws BOSException {
        if (StringUtils.isEmpty(personId)) {
            throw new BOSException("isLeader personId is null");
        }
        EmpPosOrgRelationCollection currntEmpOrgRelation = getCurrntEmpOrgRelation(ctx, personId);
        boolean isLeader = false;
        for (int i = 0; i < currntEmpOrgRelation.size(); i++) {
            EmpPosOrgRelationInfo empPosOrgRelationInfo = currntEmpOrgRelation.get(i);
            PositionInfo position = empPosOrgRelationInfo.getPosition();
            //Ƿְλ
            boolean isRespPosition = position.isIsRespPosition();
            //ְ
            AdminOrgUnitInfo adminOrg = empPosOrgRelationInfo.getAdminOrg();
            //Ų㼶
            int level = adminOrg.getLevel();
            //1.УǷΪһŸ
            if (isRespPosition && (level == 2 || level == 3)) {
                isLeader = true;
                break;
            } else {
                //2.УǷΪֱϼ(¼ְλ¼ְλ)
                EmpPosOrgRelationCollection minionOrgRelations = getCurrntEmpOrgRelationByParentPositionId(ctx, position.getId().toString());
                if (!minionOrgRelations.isEmpty()) {
                    isLeader = true;
                    break;
                }
            }
        }
        return isLeader;
    }

    /**
     * ְ
     *
     * @param ctx
     * @param leftDate
     * @param workHandoverEntryInfo
     * @throws BOSException
     */
    public static void setResignBizDate(
            Context ctx,
            Date leftDate,
            WorkHandoverEntryInfo workHandoverEntryInfo
    ) throws BOSException {
        //ȡָڵǰΧڵĹ
        WorkCalendarItemCollection workCalendarItemCollection = WorkHandoverUtil.getWorkCalendarItemCollection(ctx, SortType.DESCEND, leftDate, -30);
        //ְǹգְǰһյ
        WorkCalendarItemInfo workCalendarItemInfo = workCalendarItemCollection.get(0);
        java.util.Date date = workCalendarItemInfo.getDate();
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        int year = calendar.get(Calendar.YEAR);
        workHandoverEntryInfo.setResignYear(year);
        int money = calendar.get(Calendar.MONTH) + 1;
        workHandoverEntryInfo.setResignMonth(money);
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        workHandoverEntryInfo.setResignDay(day);
    }
}
