package com.kingdee.eas.custom.hireapproval.app;

import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.custom.hireapproval.*;
import com.kingdee.eas.hr.affair.AffairBizException;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.shr.base.syssetting.BaseItemException;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;
import com.kingdee.bos.dao.IObjectValue;

import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.common.EASBizException;

import java.lang.String;
import java.sql.Time;
import java.util.Date;

public class OfferApprovalControllerBean extends AbstractOfferApprovalControllerBean {
    private static Logger logger = Logger.getLogger(OfferApprovalControllerBean.class);

    @Override
    protected void _setAudited(Context ctx, BOSUuid billID) throws BOSException, EASBizException {
        OfferApprovalInfo info = getOfferApprovalInfo(ctx, new ObjectUuidPK(billID));
        //ͨʱ
        long time = new Date().getTime();
        info.setAudiedTime(new Time(time));
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("audiedTime");
        updatePartial(ctx, info, sic);
        super._setAudited(ctx, billID);
    }

    /**
     * ɾ
     *
     * @param ctx
     * @param pk
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _delete(Context ctx, IObjectPK pk) throws BOSException, EASBizException {
        HRBillBaseInfo info = (HRBillBaseInfo) this._getValue(ctx, pk);
        HRBillStateEnum billState = info.getBillState();
        boolean isRemovable = true;
        //ύСͨĵݲɾ
        if (HRBillStateEnum.SUBMITED.equals(billState)
                || HRBillStateEnum.AUDITING.equals(billState)
                || HRBillStateEnum.AUDITED.equals(billState)) {
            isRemovable = false;
        }
        if (!isRemovable) {
            throw new AffairBizException(AffairBizException.BILLCANTDELETE);
        }
        super._delete(ctx, pk);
    }

    /**
     * 
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _save(Context ctx, IObjectValue model) throws BOSException, EASBizException {
        OfferApprovalInfo info = (OfferApprovalInfo) model;
        //¼ԱϢ
        OfferPersonInfoInfo offerPersonInfo = info.getOfferPersonInfo();
        //н籣
        SalarySocialSecurityInfo salarySocial = info.getSalarySocial();
        //
        InterviewReviewInfo interviewReview1 = info.getInterviewReview1();
        //
        InterviewReviewInfo interviewReview2 = info.getInterviewReview2();
        //
        InterviewReviewInfo interviewReview3 = info.getInterviewReview3();
        return super._save(ctx, model);
    }

    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _untiCheckBizBill(
            Context ctx,
            String billId
    ) throws BOSException, EASBizException {
        OfferApprovalInfo info = getOfferApprovalInfo(ctx, new ObjectUuidPK(billId));
        if (info.isGenSalaryData()) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"Ѿɶн,޷"});
        }
        super._untiCheckBizBill(ctx, billId);
        //ͨʱ
        info.setAudiedTime(null);
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("audiedTime");
        updatePartial(ctx, info, sic);
    }
}