package com.kingdee.eas.custom.hireapproval.task;

import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.service.job.util.Ctx;
import com.kingdee.eas.basedata.assistant.CurrencyFactory;
import com.kingdee.eas.basedata.assistant.CurrencyInfo;
import com.kingdee.eas.basedata.assistant.ICurrency;
import com.kingdee.eas.basedata.framework.util.BDUtil;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.custom.hireapproval.*;
import com.kingdee.eas.framework.ObjectBaseInfo;
import com.kingdee.eas.hr.ats.util.AtsDateUtils;
import com.kingdee.eas.hr.emp.*;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.*;
import com.kingdee.util.IllegalConversionException;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.math.BigDecimal;
import java.util.*;

import com.kingdee.bos.*;
import com.kingdee.eas.common.EASBizException;

import static com.kingdee.eas.base.form.extend.flow.ArchiveSettingEnum.exists;

public class OfferApprovalFacadeControllerBean extends AbstractOfferApprovalFacadeControllerBean {
    private static Logger logger = Logger.getLogger(OfferApprovalFacadeControllerBean.class);
    private static Map<String, String> cmpIteNumbermMap = new HashMap<>();

    /***
     *  baseSalary    SCY002
     *  overtimePay  Ӱ๤ SCY005
     *  skillPay  ܹ  SCY003
     *  jobSubsidy  λ  SCY004
     *  TODO  Чʱ׼  SCY007
     *  TODO  ѧ׼  SCY006
     *  TODO  ò׼  SCY073
     *  TODO  ׼нʺϼ  SCY001
     *  TODO  Ƚ  SCY070
     *  TODO  ս  SCY071
     */
    static {
        cmpIteNumbermMap.put("baseSalary", "SCY002");
        cmpIteNumbermMap.put("overtimePay", "SCY005");
        cmpIteNumbermMap.put("skillPay", "SCY003");
        cmpIteNumbermMap.put("jobSubsidy", "SCY004");
        cmpIteNumbermMap.put("", "SCY007");
        cmpIteNumbermMap.put("", "SCY006");
        cmpIteNumbermMap.put("", "SCY073");
        cmpIteNumbermMap.put("", "SCY001");
        cmpIteNumbermMap.put("", "SCY070");
        cmpIteNumbermMap.put("", "SCY071");
    }

    /**
     * ɶн
     *
     * @param ctx
     * @param preDays ǰ
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _generateSalaryData(Context ctx, int preDays) throws BOSException, EASBizException {
        logger.error("_generateSalaryData--" + preDays);
        super._generateSalaryData(ctx, preDays);
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        Date toDay = cal.getTime();
        Date preDay = null;
        if (preDays <= 0) {
            preDay = toDay;
        } else {
            preDay = AtsDateUtils.getPreDay(toDay, preDays);
        }
        //1.ʱ䷶Χѯ¼״̬ΪǷɶнΪ
        IOfferApproval iOfferApproval = OfferApprovalFactory.getLocalInstance(ctx);
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("offerPersonInfo.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //ͨʱڵǰ
        filterItems.add(new FilterItemInfo("audiedTime", preDay, CompareType.GREATER_EQUALS));
        //ͨʱСڵڽ
        filterItems.add(new FilterItemInfo("audiedTime", toDay, CompareType.LESS_EQUALS));
        //״̬Ϊͨ
        filterItems.add(new FilterItemInfo("billState", "3"));
        //δɶн
        filterItems.add(new FilterItemInfo("genSalaryData", false));
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        logger.error("filterInfo--" + filterInfo.toSql());
        //¼
        OfferApprovalCollection offerApprovalCol = iOfferApproval.getOfferApprovalCollection(viewInfo);
        logger.error("offerApprovalCol--" + offerApprovalCol.size());
        //Աн
        IAdjustPersonRecord iAdjustPersonRecord = AdjustPersonRecordFactory.getLocalInstance(ctx);
        //н
        IFixAdjustSalary iFixAdjustSalary = FixAdjustSalaryFactory.getLocalInstance(ctx);
        //Ա
        IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
        //ұ
        ICurrency iCurrency = CurrencyFactory.getLocalInstance(ctx);
        //ѯенĿ
        Map<String, CmpItemInfo> cmpItemMap = new HashMap<String, CmpItemInfo>();
        ICmpItem iCmpItem = CmpItemFactory.getLocalInstance(ctx);
        CmpItemCollection cmpItemCollection = iCmpItem.getCmpItemCollection();
        for (int i = 0; i < cmpItemCollection.size(); i++) {
            CmpItemInfo cmpItemInfo = cmpItemCollection.get(i);
            cmpItemMap.put(cmpItemInfo.getNumber(), cmpItemInfo);
        }
        for (int i = 0; i < offerApprovalCol.size(); i++) {
            try {
                //ɹнṹ
                boolean isAddSucceed = false;
                //¼
                OfferApprovalInfo offerApprovalInfo = offerApprovalCol.get(i);
                //¼ԱϢ
                OfferPersonInfoInfo offerPersonInfo = offerApprovalInfo.getOfferPersonInfo();
                //н籣Ϣ 浽н⹹
                SalarySocialSecurityInfo salarySocial = offerApprovalInfo.getSalarySocial();
                //2.֤ͨպŲѯӦԱǷѾְɹ
                PersonPositionCollection personPositionColl = getPersonPositionColl(offerPersonInfo, iPersonPosition);
                if (!personPositionColl.isEmpty()) {
                    PersonPositionInfo personPositionInfo = personPositionColl.get(0);
                    //Ա
                    PersonInfo personInfo = personPositionInfo.getPerson();
                    //ԱְϢ
                    IAdjustEmpORelation iAdjustEmpORelation = AdjustEmpORelationFactory.getLocalInstance(ctx);
                    AdjustEmpORelationInfo adjustEmpORelationInfo = iAdjustEmpORelation.getAdjustEmpORelationInfo("where person.id = '" + personInfo.getId() + "'");
                    //ְͨԱѯǷڶн
                    AdjustPersonRecordCollection adjustPersonRecordCollection =
                            iAdjustPersonRecord.getAdjustPersonRecordCollection("where person.id = '" + personInfo.getId() + "'");
                    //ڶн
                    if (!adjustPersonRecordCollection.isEmpty()) {
                        // TODO ұ
                        CurrencyInfo currencyInfo = iCurrency.getCurrencyInfo(new ObjectUuidPK(""));
                        //нṹ
                        AdjustPersonRecordInfo adjustPersonRecordInfo = adjustPersonRecordCollection.get(0);
                        for (String cmpItem : cmpIteNumbermMap.keySet()) {
                            String cmpItemNubmer = cmpIteNumbermMap.get(cmpItem);
                            BigDecimal money = salarySocial.getBigDecimal(cmpItem);
                            if (money != null) {
                                //нĿ
                                CmpItemInfo comItemInfo = cmpItemMap.get(cmpItemNubmer);
                                //нṹ
                                FixAdjustSalaryInfo fixAdjustSalaryInfo = new FixAdjustSalaryInfo();
                                //нĿͽ
                                addCmpItemAndMoney(comItemInfo, money, fixAdjustSalaryInfo);
                                //ұ
                                fixAdjustSalaryInfo.setCurrency(currencyInfo);
                                //Ч =ְ
                                fixAdjustSalaryInfo.setEffectDay(personInfo.getHireDate());
                                //Ա
                                fixAdjustSalaryInfo.setPerson(personInfo);
                                //нְ
                                fixAdjustSalaryInfo.setAdjEmpORelation(adjustEmpORelationInfo);
                                //нҵ֯
                                fixAdjustSalaryInfo.setAdjHrOrgUnit(adjustPersonRecordInfo.getHrOrgUnit());
                                //֯
                                fixAdjustSalaryInfo.setAdminOrgUnit(personPositionInfo.getPersonDep());
                                //ְλ
                                fixAdjustSalaryInfo.setPosition(personPositionInfo.getPrimaryPosition());
                                //нҵ֯
                                fixAdjustSalaryInfo.setPayHrOrgUnit(adjustPersonRecordInfo.getHrOrgUnit());
                                iFixAdjustSalary.save(fixAdjustSalaryInfo);
                                isAddSucceed = true;
                            }
                        }
                    }
                }
                //нṹݴ0
                if (isAddSucceed) {
                    //3.µֶ,ǷɶнֶΪtrue (genSalaryData),ͨsql
                    String updateSql = "update from CT_HIR_OfferApproval set CFGenSalaryData = 1 where fid = ?";
                    DbUtil.execute(ctx, updateSql, new Object[]{offerApprovalInfo.getId().toString()});
                }
            } catch (Exception e) {
                e.printStackTrace();
                logger.error("ɶнݱ " + e.getMessage());
            }
        }
    }

    /**
     * ɶн
     *
     * @param item  нĿ
     * @param money ~
     */
    public void addCmpItemAndMoney(
            CmpItemInfo item,
            BigDecimal money,
            FixAdjustSalaryInfo fixAdjustSalaryInfo
    ) {
        //
        fixAdjustSalaryInfo.setMoney(money);
        //нĿ
        fixAdjustSalaryInfo.setCmpItem(item);
    }

    /**
     * @param offerPersonInfo ¼ԱϢ
     * @param iPersonPosition
     * @throws BOSException
     */
    public PersonPositionCollection getPersonPositionColl(
            OfferPersonInfoInfo offerPersonInfo,
            IPersonPosition iPersonPosition
    ) throws BOSException {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("person.*");
        sic.add("personDep.*");
        sic.add("primaryPosition.*");
        sic.add("person.employeeType.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //֤Ϊ ʹ֤Ϊ
        String idCardNO = offerPersonInfo.getIdCardNO();//֤
        //ղΪ ʹûΪ
        String passportNO = offerPersonInfo.getPassportNO();//պ
        if (StringUtils.isEmpty(idCardNO) && StringUtils.isEmpty(passportNO)) {
            throw new BOSException("֤պ벻Ϊգ");
        }
        if (!StringUtils.isEmpty(idCardNO)) {
            filterItems.add(new FilterItemInfo("person.idCardNO", idCardNO));
        }
        if (!StringUtils.isEmpty(passportNO)) {
            filterItems.add(new FilterItemInfo("person.passportNO", passportNO));
        }
        //Ƿְ
        filterItems.add(new FilterItemInfo("person.employeeType.inService", 1));
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        return iPersonPosition.getPersonPositionCollection(viewInfo);
    }
}
